#! /usr/bin/perl -w

use strict;


#########################################################
#
# (c) Serxio Barral - 2005
#
# lmon.pl
#
# This perl program collects performance data on Linux  
#
#
#
#  This program is free software published under the
#  terms of the GNU General Public License.
#
#  For the entire license text please refer to
#  http://www.gnu.org/licenses/gpl.html
#
#
#  Serial __212
#
#########################################################


# VAR

my $hostname       = '';
my $interval       = 6;
my $samples        = 20;
my $infinite       = 1000000;
my $time           = time();
my $currentsamples = 0;

my %filehash = (
                  "hostname" => "/proc/sys/kernel/hostname",
                  "procstat" => "/proc/stat",
                  "cpuinfo"  => "/proc/cpuinfo",
                  "meminfo"  => "/proc/meminfo",
                  "loadavg"  => "/proc/loadavg",
                  "netdev"   => "/proc/net/dev"
               );


##### CPU #######

my %cpuvirtualtophysicalhash = ();
my %cpuphysicalhash   =();
my $cpuvirtualnumber  = 0;
my $cpuphysicalnumber = 0;

my $userjiffies  = "0";
my $sysjiffies   = "0";
my $idlejiffies  = "0";
my $nicejiffies  = "0";
my $totaljiffies = "0";

my $olduserjiffies  = "0";
my $oldsysjiffies   = "0";
my $oldidlejiffies  = "0";
my $oldnicejiffies  = "0";
my $oldtotaljiffies = "0";

my %userjiffiespercpu  = ();
my %sysjiffiespercpu   = ();
my %idlejiffiespercpu  = ();
my %nicejiffiespercpu  = ();
my %totaljiffiespercpu = ();

my %olduserjiffiespercpu   = ();
my %oldsysjiffiespercpu    = ();
my %oldidlejiffiespercpu   = ();
my %oldnicejiffiespercpu   = ();
my %oldtotaljiffiespercpu  = ();

##### END CPU #######

##### MEMORY #######

my $memtotalkb  = 0;
my $memfreekb   = 0;
my $swaptotalkb = 0;
my $swapfreekb  = 0;

my $realfreepercent     = 0;
my $virtualfreepercent  = 0;
my $realfree            = 0;
my $virtualfree         = 0;
my $realtotal           = 0;
my $virtualtotal        = 0;
my $avm                 = 0;

##### END MEMORY #######

##### PAGE #######

my $pagein     = 0;
my $pageout    = 0;
my $swapin     = 0;
my $swapout    = 0;
my $oldpagein  = 0;
my $oldpageout = 0;
my $oldswapin  = 0;
my $oldswapout = 0;

##### END PAGE #######


##### LOADAVG #######

my $loadavg = 0;

##### END LOADAVG #######


##### NET #######

my %interfacebytesinhash;
my %interfacebytesouthash;
my %interfacepacketsinhash;
my %interfacepacketsouthash;
my %oldinterfacebytesinhash;
my %oldinterfacebytesouthash;
my %oldinterfacepacketsinhash;
my %oldinterfacepacketsouthash;

##### END NET #######

##### DISK #######
my %oldsectorswritten;
my %oldsectorsread;
my %sectorswritten;
my %sectorsread;
my %cdroms;
my $sectorsize = 512;
##### END DISK #######

# ENDVAR


sub FirstCalcDisk()
{
   my $disk = "";
   my $sectorsread    = 0;
   my $sectorswritten = 0;

   # First thing, we seek for cd-rom's

   open (DMSG,"/bin/dmesg |");
   while (<DMSG>) 
   {
      chomp($_);

      if ($_ =~ /(hd|sd)([a-z]):.*(cd-r|dvd-r|cdrom).*/i)  
      {
         my $cdrom = $1.$2;

         # This disk is a cdrom

         $cdroms{$cdrom} = 1; 
      }
   }
   close (DMSG);

   &GetDisk(); 

   print "DISKREAD,Disk Read kb/s $hostname";

   foreach $disk  (sort keys %sectorsread) 
   {
      print ",$disk";
   }

   print "\n";

   print "DISKWRITE,Disk Read kb/s $hostname";

   foreach $disk (sort keys %sectorswritten) 
   {
      print ",$disk";
   }

   print "\n";
}

sub CalcDisk()
{
   my $disk = "";
   my $sectorsread    = 0;
   my $sectorswritten = 0;


   %oldsectorsread    = %sectorsread; 
   %oldsectorswritten = %sectorswritten; 

   &GetDisk(); 

   print "DISKREAD,$time";

   foreach $disk  (sort keys %sectorsread) 
   {
      $sectorsread  = $sectorsread{$disk}    - $oldsectorsread{$disk};

      my $kbsreadpersecond = ($sectorsread * $sectorsize / $interval);

      print ",$kbsreadpersecond";
   }

   print "\n";

   print "DISKWRITE,$time";
   foreach $disk (sort keys %sectorswritten) 
   {
      $sectorswritten = $sectorswritten{$disk} - $oldsectorswritten{$disk};

      my $kbswrittenpersecond = ($sectorswritten * $sectorsize / $interval);

      print ",$kbswrittenpersecond";
   }

   print "\n";
}

sub GetDisk()
{
   if (-f "/proc/diskstats")
   {
      if (open (DISKSTATS,"< /proc/diskstats"))
      {
         while (<DISKSTATS>)
         {
            chomp($_);

            if ($_ =~ /(hd|sd)([a-z])\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)/)
            {
               my $disk = $1.$2;

               if (!exists($cdroms{$disk}))
               {
                  $sectorsread{$disk}    = $5;

                  $sectorswritten{$disk} = $7;
               }

            }
         }
         close (DISKSTATS);
      }
   }
}

sub GetNet()
{
   # VAR
   # ENDVAR

   if (open (NETDEV,"< $filehash{netdev}"))
   {
      while (<NETDEV>)
      {
         if ($_ =~ /^\s+(\w+):\s*(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)/)
         {
            $interfacebytesinhash{$1}    = $2;
            $interfacepacketsinhash{$1}  = $3;
            $interfacebytesouthash{$1}   = $10;
            $interfacepacketsouthash{$1} = $11;
         }
      }
      close (NETDEV);
   } 
   else
   {
      print STDERR "No se ha podido abrir fichero $filehash{netdev}\n"; 
   }
}

sub CalcNet()
{
   # VAR
      my $key;
      my %interfaceKBpersecondinhash;
      my %interfaceKBpersecondouthash;
      my %interfacepacketspersecondinhash;
      my %interfacepacketspersecondouthash;
      my $canprint = 1;
   # ENDVAR

   foreach $key (keys %interfacebytesinhash)
   {
      $oldinterfacebytesinhash{$key}    = $interfacebytesinhash{$key};
      $oldinterfacebytesouthash{$key}   = $interfacebytesouthash{$key};
      $oldinterfacepacketsinhash{$key}  = $interfacepacketsinhash{$key};
      $oldinterfacepacketsouthash{$key} = $interfacepacketsouthash{$key};
   }

   &GetNet();

   foreach $key (keys %interfacebytesinhash)
   {
      $interfaceKBpersecondinhash{$key}       = ($interfacebytesinhash{$key}    - $oldinterfacebytesinhash{$key})   / (1024*$interval);
      $interfaceKBpersecondouthash{$key}      = ($interfacebytesouthash{$key}   - $oldinterfacebytesouthash{$key})  / (1024*$interval);
      $interfacepacketspersecondinhash{$key}  = ($interfacepacketsinhash{$key}  - $oldinterfacepacketsinhash{$key}) / $interval;
      $interfacepacketspersecondouthash{$key} = ($interfacepacketsouthash{$key} - $oldinterfacepacketsouthash{$key})/ $interval;

 
      if (($interfaceKBpersecondinhash{$key} < 0)||($interfaceKBpersecondouthash{$key} < 0)||($interfacepacketspersecondinhash{$key} < 0)||($interfacepacketspersecondouthash{$key}<0))
      {
         $canprint = 0;
      }
   }

   if ($canprint)
   {
      print "NET,$time";

      foreach $key  (sort keys %interfacebytesinhash)
      {
         print ",$interfaceKBpersecondinhash{$key}"
      }
      foreach $key (sort keys %interfacebytesinhash)
      {
         print ",$interfaceKBpersecondouthash{$key}"
      }
      print "\n";

      print "NETPACKET,$time";

      foreach $key (sort keys %interfacebytesinhash)
      {
         print ",$interfacepacketspersecondinhash{$key}"
      }
      foreach $key (sort keys %interfacebytesinhash)
      {
         print ",$interfacepacketspersecondouthash{$key}"
      }
      print "\n";
   }

}

sub FirstCalcNet()
{
   # VAR
   my $key=0;
   # ENDVAR
   &GetNet();

   print "NET,Network I/O $hostname";

   foreach $key  (sort keys %interfacebytesinhash)
   {
      print ",$key-read-KB/s"
   }
   foreach $key (sort keys %interfacebytesouthash)
   {
      print ",$key-write-KB/s"
   }
   print "\n";

   print "NETPACKET,$time";

   foreach $key (sort keys %interfacebytesinhash)
   {
      print ",$key-reads/s"
   }
   foreach $key (sort keys %interfacebytesouthash)
   {
      print ",$key-writes/s"
   }
   print "\n";
}

sub GetProc()
{
   # VAR
   # ENDVAR

   if (open (LOADAVG,"< $filehash{loadavg}"))
   {
      while (<LOADAVG>)
      {
         if ($_ =~ /^(\d+\.*\d*)\s+(\d+\.*\d*)\s+(\d+\.*\d*)\s+(\d+\.*\d*)\/(\d+)\s(\d+)/) 
         {
            $loadavg=$1;
         }
      }
      close (LOADAVG);
   } 
   else
   {
      print STDERR "Could not open file $filehash{loadavg}\n"; 
   }
}

sub CalcProc()
{
   &GetProc();

   print "PROC,$time,$loadavg,0,0,0,0,0,0,0,0,0,0,0\n";
}

sub GetPage()
{
   # VAR
   # ENDVAR

   if (open (PAGE,"< $filehash{procstat}"))
   {
      while (<PAGE>)
      {
         if ($_ =~ /^page\s+(\d+)\s+(\d+)/) 
         {
            $pagein  = $1;
            $pageout = $2;
         }
         if ($_ =~ /^swap\s+(\d+)\s+(\d+)/) 
         {
            $swapin  = $1;
            $swapout = $2;
         }

      }
      close (PAGE);
   } 
   else
   {
      print STDERR "Could not open file $filehash{procstat}\n"; 
   }
}


sub CalcPage()
{
   # VAR
   my $currentpagein  = 0;
   my $currentpageout = 0;
   my $currentswapin  = 0;
   my $currentswapout = 0;

   # ENDVAR
   $oldpagein  = $pagein;
   $oldpageout = $pageout;
   $oldswapin  = $swapin;
   $oldswapout = $swapout;

   &GetPage();

   $currentpagein  = ($pagein - $oldpagein)  / $interval;
   $currentpageout = ($pageout - $oldpageout)/ $interval;
   $currentswapin  = ($swapin - $oldswapin)  / $interval;
   $currentswapout = ($swapout - $oldswapout)/ $interval;

   if (($currentpagein >= 0) && ($currentpageout >= 0) && ($currentswapin >= 0) && ($currentswapout >= 0))
   {
      print "PAGE,$time,0,$currentpagein,$currentpageout,$currentswapin,$currentswapout,0,0,0\n";
   }
}

sub CalcMemuse()
{
   print "MEMUSE,$time,0,0,0,0,0\n";
}

sub GetMemory()
{
   # VAR
   $memfreekb = 0;
   # ENDVAR

   if (open (MEMINFO,"< $filehash{meminfo}"))
   {
      while (<MEMINFO>)
      {
         if ($_ =~ /MemTotal:\s+(\d+)\s+kB/i)
         {
            $memtotalkb = $1;
         }
         elsif (($_ =~ /MemFree:\s+(\d+)\s+kB/i) || ($_ =~ /Buffers:\s+(\d+)\s+kB/i) || ($_ =~ /Cached:\s+(\d+)\s+kB/i))
         {
            $memfreekb = $memfreekb + $1;
         }
         elsif ($_ =~ /SwapTotal:\s+(\d+)\s+kB/i)
         {
            $swaptotalkb = $1;
         }
         elsif ($_ =~ /SwapFree:\s+(\d+)\s+kB/i)
         {
            $swapfreekb = $1;
         }
       
      }
      close (MEMINFO);
   } 
   else
   {
      print STDERR "Could not open file $filehash{meminfo}\n"; 
   }
}

sub CalcMemory()
{
   &GetMemory();

   $realfreepercent     = ($memfreekb/$memtotalkb)   * 100;
   $virtualfreepercent  = ($swapfreekb/$swaptotalkb) * 100;
   $realfree            = $memfreekb/1024;
   $virtualfree         = $swapfreekb/1024;
   $realtotal           = $memtotalkb/1024;
   $virtualtotal        = $swaptotalkb/1024; 
   $avm                 = $realtotal-$realfree;

   print "MEM,$time,$realfreepercent,$virtualfreepercent,$realfree,$virtualfree,$realtotal,$virtualtotal,$avm\n";
   
}

sub GetCPU()
{
   if (open (PROCSTAT,"< $filehash{procstat}"))
   {
      # VAR
      my $key = 0;
      # ENDVAR

      foreach $key (keys %cpuphysicalhash)
      {
         $userjiffiespercpu{$key}  = 0;
         $nicejiffiespercpu{$key} = 0;
         $sysjiffiespercpu{$key}  = 0;
         $idlejiffiespercpu{$key} = 0;
      }

      while (<PROCSTAT>)
      {
         chomp($_); 
 
         if ($_ =~ /^cpu\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)/)
         {
            $userjiffies = $1;
            $nicejiffies = $2;
            $sysjiffies  = $3;
            $idlejiffies = $4;
            $totaljiffies = $userjiffies + $nicejiffies + $sysjiffies + $idlejiffies;
         }
         elsif ($_ =~ /^cpu(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)/)
         {
            $userjiffiespercpu{$cpuvirtualtophysicalhash{$1}} = $userjiffiespercpu{$cpuvirtualtophysicalhash{$1}} + $2;
            $nicejiffiespercpu{$cpuvirtualtophysicalhash{$1}} = $nicejiffiespercpu{$cpuvirtualtophysicalhash{$1}} + $3;
            $sysjiffiespercpu{$cpuvirtualtophysicalhash{$1}}  = $sysjiffiespercpu{$cpuvirtualtophysicalhash{$1}} + $4;
            $idlejiffiespercpu{$cpuvirtualtophysicalhash{$1}} = $idlejiffiespercpu{$cpuvirtualtophysicalhash{$1}} + $5;
         }
      }
      close (PROCSTAT);

      foreach $key (keys %cpuphysicalhash)
      {
         $totaljiffiespercpu{$key} = $userjiffiespercpu{$key} + 
                                                              $nicejiffiespercpu{$key} +
                                                              $sysjiffiespercpu{$key} + 
                                                              $idlejiffiespercpu{$key}; 
      }
   }
   else
   {
      print STDERR "Could not open file $filehash{procstat}\n"; 
   }
}

sub CalcCPU()
{
   
   # VAR
   my $index = 1;
   my $key   = 0;  
   # ENDVAR

   $olduserjiffies  = $userjiffies;
   $oldnicejiffies  = $nicejiffies;
   $oldsysjiffies   = $sysjiffies;
   $oldidlejiffies  = $idlejiffies; 
   $oldtotaljiffies = $totaljiffies;

   foreach $key (keys %cpuphysicalhash)
   {
      $olduserjiffiespercpu{$key} = $userjiffiespercpu{$key};
      $oldnicejiffiespercpu{$key} = $nicejiffiespercpu{$key};
      $oldsysjiffiespercpu{$key}  = $sysjiffiespercpu{$key};
      $oldidlejiffiespercpu{$key} = $idlejiffiespercpu{$key};
      $oldtotaljiffiespercpu{$key} = $totaljiffiespercpu{$key};
   }

   &GetCPU();

   # Now we do have both old and new values

   my $percentuser  = ($userjiffies - $olduserjiffies)/($totaljiffies - $oldtotaljiffies)*100;
   my $percentnice  = ($nicejiffies - $oldnicejiffies)/($totaljiffies - $oldtotaljiffies)*100;
   my $percentsys   = ($sysjiffies - $oldsysjiffies)/($totaljiffies - $oldtotaljiffies)*100;
   my $percentidle  = ($idlejiffies - $oldidlejiffies)/($totaljiffies - $oldtotaljiffies)*100;

   if (($percentuser >= 0) && ($percentnice >= 0) && ($percentsys >= 0) && ($percentidle >= 0))
   {
      print "CPU_ALL,$time,$percentuser,$percentsys,$percentnice,$percentidle,,$cpuphysicalnumber\n";
   }

   foreach $key (keys %cpuphysicalhash)
   {
      
      $percentuser  = ($userjiffiespercpu{$key} - $olduserjiffiespercpu{$key})/($totaljiffiespercpu{$key} - $oldtotaljiffiespercpu{$key})*100;
      $percentnice  = ($nicejiffiespercpu{$key} - $oldnicejiffiespercpu{$key})/($totaljiffiespercpu{$key} - $oldtotaljiffiespercpu{$key})*100;
      $percentsys   = ($sysjiffiespercpu{$key} - $oldsysjiffiespercpu{$key})/($totaljiffiespercpu{$key} - $oldtotaljiffiespercpu{$key})*100;
      $percentidle  = ($idlejiffiespercpu{$key} - $oldidlejiffiespercpu{$key})/($totaljiffiespercpu{$key} - $oldtotaljiffiespercpu{$key})*100;

      
      if (($percentuser >= 0) && ($percentnice >= 0) && ($percentsys >= 0) && ($percentidle >= 0))
      {
         if ($index < 10)
         {
            print "CPU0$index,$time,$percentuser,$percentsys,$percentnice,$percentidle\n";
         }
         else
         {
            print "CPU$index,$time,$percentuser,$percentsys,$percentnice,$percentidle\n";
         }
         $index++;
      }
  }
}

sub FirstCalcCPU()
{

   # Obtaining cpu data
   if (open (CPUINFO,"< $filehash{cpuinfo}"))
   {
      # VAR
      my $waitingforid = 0;
      my $virtualid    = 0;
      my $key          = 0;
      my $index        = 1;
      # ENDVAR

      while (<CPUINFO>)   
      {
         if ($_ =~ /^processor\s+:\s+(\d)/) 
         {
            if (!$waitingforid)
            {
               $virtualid    = $1;
               $waitingforid = 1;  
    
            }
            else
            {
               $cpuvirtualtophysicalhash{$virtualid} = $virtualid; # Para sistemas sin HT
               $cpuphysicalhash{$virtualid}=1;
            }
         }
         elsif ($_ =~ /^physical id\s+:\s+(.+)/)
         {
            $cpuvirtualtophysicalhash{$virtualid} = $1;      
            $cpuphysicalhash{$1}=1;
            $waitingforid = 0;  
         }
         else
         {
            $virtualid = $1;
         }
      }

      close (CPUINFO);

      if ($waitingforid)
      {
         $cpuvirtualtophysicalhash{$virtualid} = $virtualid; # Para sistemas sin HT
         $cpuphysicalhash{$virtualid}=1;
      }
 
      $cpuphysicalnumber = keys %cpuphysicalhash;
      $cpuvirtualnumber  = keys %cpuvirtualtophysicalhash;

      print "CPU_ALL,CPU Total $hostname,User%,Sys%,Nice%,Idle%,Busy,CPUs\n";

      for ($index=0;$index < $cpuphysicalnumber;$index++)
      {
         if ($index < 10)
         {
            print "CPU0$index,CPU $index $hostname,User%,Sys%,Nice%,Idle%\n";
         }
         else
         {
            print "CPU$index,CPU $index $hostname,User%,Sys%,Nice%,Idle%\n";
         }
      }

   }
   else
   {
      print STDERR "Could not open file $filehash{cpuinfo}\n";
   }
   &GetCPU();
}

sub GetMeasure()
{
   $time = time();
   ###print "ALARM: $hostname\n";
   
   &CalcCPU();
   &CalcMemory();
   &CalcMemuse();
   &CalcPage();
   &CalcProc();
   &CalcNet();
   &CalcDisk();
   alarm($interval);
   $currentsamples++;

   if ($currentsamples == $samples)
   {
      exit 0;
   }
}

# MAIN

$time = time();

# Obtaining hostname

if (open (HOSTNAME,"< $filehash{hostname}"))
{
   $hostname = <HOSTNAME>;

   chomp($hostname);

   close (HOSTNAME);
}
else
{
   print STDERR "Could not open file $filehash{hostname}\n";
}




# Programing alarm signal

$SIG{ALRM} = \&GetMeasure;

# Starting to get measures! 

&FirstCalcCPU();
&GetPage();
&FirstCalcNet();
&FirstCalcDisk();

alarm($interval);

while (1 == 1)
{
   sleep ($infinite);
   
}
