#! /bin/sh

###########################################
#
# (c) Serxio Barral 2006
#
# Very simple installer for SUMon files
#
# __Serial# 15
#
###########################################

. ./lib/installhelper.sh


OLDBINDIR="/usr/local/bin"
OLDVARDIR="/var/sumon"
OLDSTATDIR="/var/sumon/stats"
BINDIR="/opt/sumon/agent/bin"
VARDIR="/var/sumon/agent"
ETCDIR="/etc/sumon/agent"
RUNDIR="/var/sumon/run"
STATDIR="/var/sumon/agent/stats"
DATE=`date +"%Y%m%d_%H%M%S"`

BINFILES="lmon.pl statsagent.pl changeagent.pl sumonagent.pl"
CONFIGFILES="statsagent.conf changeinfo.conf sumonagent.conf"
NOPATTERNCONFIGFILES="changeinfo.conf"
PATTERNCONFIGFILES="statsagent.conf changeinfo.conf sumonagent.conf"

clear

export OVERWRITECONFIGFILES="TRUE"




while getopts "cd" OPTION
do      case "$OPTION" in
        c) OVERWRITECONFIGFILES="FALSE";;
        *) ;;
        esac
done

for dir in ${BINDIR} ${VARDIR} ${ETCDIR} ${RUNDIR} ${STATDIR}
do
   [ -d ${dir} ] || {
      mkdir -p ${dir}
   }
done




# Erasing older versions (< 0.7.0)

[ -d ${OLDSTATDIR}/out ] && {

   mv ${OLDSTATDIR}/out ${STATDIR}

   rmdir ${OLDTSTATDIR} > /dev/null 2>&1
}


for file in ${BINFILES}
do
   FILE="${OLDBINDIR}/${file}"

   [ -f ${FILE} ] && rm ${FILE}
done





# Copying newer versions

for file in ${BINFILES}
do
   cp ./agent/bin/${file} ${BINDIR}
done


# Backing up config files
for configfile in ${CONFIGFILES}
do
   FILE=${ETCDIR}/${configfile}

   [ -f ${FILE} ] && {
      cp ${FILE} ${FILE}.${DATE}
      echo
      if [ "${OVERWRITECONFIGFILES}" == "TRUE" ]
      then
         echo "WARNING*** copied and replaced file ${FILE} to ${FILE}.${DATE}"
         echo "please, if you made any change to this file you should replicate them in the new file"
         echo
      fi
   }
done

for configfile in ${NOPATTERNCONFIGFILES}
do
   cp ./agent/etc/${configfile} ${ETCDIR}
done

getMaster

for configfile in ${PATTERNCONFIGFILES}
do

   sed -e "s/__MASTER__/$MASTER/g" ./agent/etc/${configfile} > ${ETCDIR}/${configfile}
done

if [ $OVERWRITECONFIGFILES == "FALSE" ]
then
   for configfile in $CONFIGFILES
   do
      FILE=${ETCDIR}/${configfile}
      [ -f ${FILE}.${DATE} ] && {
         cp ${FILE}.${DATE} ${FILE}
      }
   done
fi


checkForRsync || {
   displayRsyncMessageforAgent
}

echo
echo
echo
echo "Please, check rsync server is configured and    "
echo "running in your master server                   "
echo
echo
echo "You can start agent now by executing:           "
echo "${BINDIR}/sumonagent.pl                         "
