#! /bin/sh

###########################################
#
# (c) Serxio Barral 2006
#
# Very simple installer helper for SUMon
#
# _Serial# 1
#
###########################################

function displayRsyncMessageforServer {

    echo "It seems that you don't have rsync installed"
    echo "" 
    echo "Sumon needs rsync for data transfer..."
    echo ""
    echo "Please, install rsync and configure a repository for it" 
    echo ""
    echo "This repository defaults to /var/sumon/server, and should be named Sumon"
}

function displayRsyncMessageforAgent {

    echo "It seems that you don't have rsync installed"
    echo "" 
    echo "Sumon needs rsync for data transfer..."
    echo ""
    echo "Please, install rsync" 
}

function checkForRsync {

GUESSPATHS="/usr/bin /usr/local/bin"
RES=1

  type rsync > /dev/null 2>&1

  if [ $? -eq 0 ]
  then
     RES=0
  else
     for path in ${GUESSPATHS}
     do
        [ -x ${path}/rsync ] && {
           RES=0
        }
     done
  fi

  return ${RES}
}

function checkForRRDTOOL {

GUESSPATHS="/usr/bin /usr/local/bin"
RES=1
RRDTOOL=rrdtool

  type rrdtool > /dev/null 2>&1

  if [ $? -eq 0 ]
  then
     RES=0
  else
     for path in ${GUESSPATHS}
     do
        [ -x ${path}/rrdtool ] && {
           RES=0
           RRDTOOL=${path}/rrdtool  
        }
     done
  fi

  if [ ${RES} -eq 0 ]
  then
     ${RRDTOOL} | grep -i "1\.0" > /dev/null 2>&1 || {
        echo ""
        echo ""
        echo "WARNING... It seems that the version of rrdtool you have installed is not"
        echo "supported by Sumon. Sumon currently supports rrdtool 1.0.x"
        echo ""
        echo ""
     } 
  else
        echo ""
        echo ""
        echo "Can't find rrdtool installed, please check you have it installed and it is"
        echo "version 1.0.x"
        echo ""
        echo ""
  fi
  return ${RES}
}

function getYN {
    
    ANSWER=""

    while [ "_${ANSWER}_" != "_y_" -a "_${ANSWER}_" != "_n_" ]
    do
       read INSTRING

       ANSWER=`perl -e "print lc(\"$INSTRING\");"`

       if [ "_${ANSWER}_" != "_y_" -a "_${ANSWER}_" != "_n_" ] 
       then
          echo please, enter y or n!          
       fi
    done
}

function getMaster {

   GOODMASTER=FALSE

   while [ ${GOODMASTER} == "FALSE" ]
   do
      echo
      echo
      echo
      echo "Please, enter your master server ip address or name:"
      read MASTER
      echo
      echo
      echo

      if  [ "_${MASTER}_" != "__" ]
      then
         ping -c 1 ${MASTER} > /dev/null 2>&1 || {
            echo "Mmmmmm, ${MASTER} seems not to be alive..."
         }
         echo 
         echo
         echo "You have entered ${MASTER}, is this ok? (y/n)"
       
         getYN

         if [ "_${ANSWER}_" == "_y_" ]
         then
            GOODMASTER="TRUE"
         fi
      fi 
   done
}
