#! /usr/bin/perl -w

#########################################################
#
# (c) Serxio Barral - 2006
#
# chmgmtinfobuilder.pl
#
# This perl program generates web output for the changes
# recorded in /var/sumon/server/data/chgmgmtinfo
#
#
#
#  This program is free software published under the
#  terms of the GNU General Public License.
#
#  For the entire license text please refer to
#  http://www.gnu.org/licenses/gpl.html
#
#  Serial: _78
#
#########################################################


use strict;
use Time::localtime;


# VAR
   my $BASEDIR      = "/var/sumon/server";
   my $DATADIR      = $BASEDIR."/data";
   my $CHGMGMTDIR   = $DATADIR."/chgmgmtinfo";
   my $hostname     = "";
   my @files        = ();
   my @commands     = ();
   my $insert       = 0;
   my $repository   = "";
   my $file         = "";
   my $command      = "";
   my $tmpdir       = "/tmp";
   my $tmpfile      = $tmpdir."/chgmgmt.tmp";
   my $timestamp    = time();

   my %machines     = ();
   my $machine      = ();
   my $parameter    = "";
   my $limithours   = 0;
   my $limitdays    = 0; 
   my $limitmonths  = 0;
   my $limittime    = 0;
   my $notlimitdef  = 0;
   my $chgonly      = 0;
   my $node         = "";
   my $nodedef      = 0; 
   my $html         = 0; 
   my @filestoprinthtml = ();
# ENDVAR


foreach $parameter (@ARGV)
{
   if ($parameter =~ /--(\w+)=([^\s]+)/)
   {
      if ($1 eq "hours") 
      {
         $limithours  =  $2;
         $notlimitdef =  1;
      }
      elsif ($1 eq "days") 
      {
         $limitdays   =  $2;
         $notlimitdef =  1;
      }
      elsif ($1 eq "montsh") 
      {
         $limitmonths =  $2;
         $notlimitdef =  1;
      }
      elsif ($1 eq "node")
      {
         $node    = $2;
         $nodedef = 1;
      }
      else
      {
         &usageMessage;
      } 
   }
   elsif ($parameter =~ /--(\w+)/)
   {
      if ($1 eq "chgonly")
      {
         $chgonly =  1;
      }
      elsif ($1 eq "html")
      {
         $html =  1;
      }
      else
      {
         &usageMessage;
      }
   }
   else
   {
      die "Use: ChmgmtInfoBuilder.pl  [--help|--days=nn|--monts=nn|--years=nn]";
   }
} # end foreach

$limittime = ($limithours*3600) + ($limitdays*24*3600) + ($limitmonths*30*24*3600);




open (MACHINESFIND,"/usr/bin/find $CHGMGMTDIR -type d |");

while (<MACHINESFIND>)
{
   chomp($_);
   if ($_ =~ /\/chgmgmtinfo\.([^\/]+)$/)
   {
      # VAR
      my @filearray     = ();
      # ENDVAR

      $machines{$1} = \@filearray;
      ###print "$1\n";
   }
}
close (MACHINESFIND);

for $machine (keys %machines)
{
   # VAR
   my $machinedir = $CHGMGMTDIR."/chgmgmtinfo.".$machine;
   my $file       = "";
   my @files      = ();
   my %last       = ();
   # ENDVAR
   if (!$nodedef   || ($node eq $machine) || ($node eq "all"))
   {

      if ($html)
      {
         #print "<tr><td>FILE</td><td>CONCEPT</td><td>DATE</td><td>PREVIOUS DATE</td><td></td><td></td></tr>\n";

      }
      else
      {
         print "$machine\n";
      }

      open (SINGLEMACHINEFIND,"/usr/bin/find $machinedir -type f |");
      while (<SINGLEMACHINEFIND>)
      {
         ###print "   $_"; 
         chomp ($_);

         if ($_ =~ /([^\/]+:\d+:\d+)$/)
         {
            push (@{$machines{$machine}},"$1");
         }
      }
      close (SINGLEMACHINEFIND);

      @files = (sort { timestamp($a) <=> timestamp($b) } @{$machines{$machine}}); # Sorting by timestamp
     
      foreach $file (@files)
      {  
         # VAR
         my $realname    = "";
         my $date        = "";
         my $encodedname = "";
         my $timestamp   = "";
         my $hour        = "";
         my $min         = "";
         my $year        = "";
         my $month       = "";
         my $day         = "";
         # ENDVAR
 
         ###print "$file<br>\n";

         if ($file =~ /([^:]+):(\d+):(\d+)$/)
         {
            # VAR
            my %lastdata    = ();
            my $now         = time();
            my $extrastring = "";
            my $checksum    = "";
            # ENDVAR
            $encodedname    = $1;
            $timestamp      = $2; 
            $checksum       = $3;
            $realname       = stringDecode ($encodedname); 
            $date           = localtime($timestamp);
          
            $hour           = sprintf("%02d",$date->hour);
            $min            = sprintf("%02d",$date->min);
            $year           = $date->year+1900;
            $month          = sprintf("%02d",$date->mon+1);
            $day            = sprintf("%02d",$date->mday);

            # ENDVAR
            my $totalfilenamehtml   = "";
            my $filenametoprinthtml = "";
            my $encodedfilenamehtml = "";
            # ENDVAR

            $realname =~ s/^(COMMAND|FILE)//g;

            $totalfilenamehtml   = "chgmgmtinfo/" . "chgmgmtinfo." . $machine . "/" . $encodedname . "/" . $file;

            $encodedfilenamehtml = $totalfilenamehtml;


            $filenametoprinthtml = "<form  action=\"showfile.php\" method=\"post\" target=\"File\"> <input type=\"hidden\" name=\"fichero_post\" value=\"$encodedfilenamehtml\"> <input type=\"submit\"  value=\" See the file \" onclick=\"JavaScript:window.open(\'showfile.php\','File','width=450,height=275,menubar=no,scrollbars=yes,toolbar=no,location=no,directories=no,resizable=yes,top=0,left=0')\"> </form>";
         

            if ($checksum == 0)
            {
               if (defined $last{$encodedname}) 
               {
                  $extrastring = "deleted";
               }
               else
               {
                  $extrastring =  "does not exist";
               }
            }
            else
            {
               if (defined $last{$encodedname}) 
               {
                  $extrastring = "change";
               }
               else
               {
                  $extrastring =  "new";
               }
            }
        
  
            if (!$notlimitdef || (($now - $limittime) <= $timestamp))
            {
               if (defined $last{$encodedname})
               {

                  if ($html)
                  {
                     # VAR
                     my $difffilenametoprinthtml = ""; 
                     # ENDVAR

                  $difffilenametoprinthtml = "<form  action=\"difffile.php\" method=\"post\" target=\"File\"> <input type=\"hidden\" name=\"fichero_post\" value=\"$encodedfilenamehtml\"> <input type=\"hidden\" name=\"antiguofichero_post\" value=\"$last{$encodedname}->{encodedfilenamehtml}\"><input type=\"submit\"  value=\" Compare with previous version \" onclick=\"JavaScript:window.open(\'difffile.php\','File','width=450,height=275,menubar=no,scrollbars=yes,toolbar=no,location=no,directories=no,resizable=yes,top=0,left=0')\"> </form>";

                     push (@filestoprinthtml, "<tr><td class=\"stylea\">$realname</td><td class=\"styleb\">$extrastring</td><td class=\"stylea\"><table><tr><td>$day-$month-$year</td><td>$hour:$min</td></tr></table></td><td class=\"styleb\"><table><tr><td>$last{$encodedname}->{day}-$last{$encodedname}->{month}-$last{$encodedname}->{year}</td><td>$last{$encodedname}->{hour}:$last{$encodedname}->{min}</td></tr></table></td><td class=\"stylea\">$filenametoprinthtml</td><td class=\"styleb\">$difffilenametoprinthtml</td></tr>\n");
                  }
                  else
                  {
                     print "     Change   $realname $extrastring --> $hour:$min $day-$month-$year,  previous --> $last{$encodedname}->{hour}:$last{$encodedname}->{min} $last{$encodedname}->{day}-$last{$encodedname}->{month}-$last{$encodedname}->{year}\n";
                  }
               }
               else
               {
                  if (!$chgonly)
                  {
                     if ($html)
                     {
                        print "<tr><td>Fichero inicial</td><td></td><td>$realname</td><td></td><td>$extrastring</td><td></td><td><table><tr><td>$day-$month-$year</td><td>$hour:$min</td></tr></table></td><td></td><td></td><td></td><td></td></tr>\n";
                     }
                     else
                     {
                        print "     Initial file $realname $extrastring --> $hour:$min $day-$month-$year\n"; 
                     }
                  }               
               }
            }
            $last{$encodedname}             = \%lastdata;
            $last{$encodedname}->{realname} = $realname;
            $last{$encodedname}->{hour}     = $hour;
            $last{$encodedname}->{min}      = $min;
            $last{$encodedname}->{year}     = $year;
            $last{$encodedname}->{month}    = $month;
            $last{$encodedname}->{day}      = $day;
            $last{$encodedname}->{encodedfilenamehtml} = $encodedfilenamehtml;
         }
      }

      if ($html)
      {
         my $stringtoprinthtml;

         if (@filestoprinthtml > 0)
         {
            print "<table>\n";

            print "<th class=\"stylea\">FILE</th><th class=\"styleb\">CONCEPT</th><th class=\"stylea\">DATE</th><th class=\"styleb\">PREVIOUS DATE</th><th class=\"styleb\"></th><th class=\"styleb\"></th>\n";

            foreach $stringtoprinthtml (@filestoprinthtml)
            {
               print $stringtoprinthtml."\n";
            }

            print "</table>\n";
         }
         else
         {
            print "<p> Not changes found in this period! </p>\n";
         }
      }
      else
      {
         print "\n\n";
      }
   }
}

sub stringEncode
{
   my $theURL = $_[0];
   $theURL =~ s/([\W])/"%" . uc(sprintf("%2.2x",ord($1)))/eg;
   return $theURL;
}

sub stringDecode
{
    my $theURL = $_[0];
    $theURL =~ tr/+/ /;
    $theURL =~ s/%([a-fA-F0-9]{2,2})/chr(hex($1))/eg;
    $theURL =~ s/<!--(.|\n)*-->//g;
    return $theURL;
}

sub timestamp()
{
   my $filename = $_[0];
   my $res      = 0;

   if ($filename =~ /[^:]+:(\d+):\d+/)
   {
      $res = $1;
   }

   return $res;
}
  
sub usageMessage()
{
      die "Uso: ChmgmtInfoBuilder.pl  [--help|--days=nn|--monts=nn|--years=nn|--chgonly]";
}
